SystemOrganization addCategory: #'Magma-Seaside-ExampleStore'!

WAComponent subclass: #WAStoreOrderView
	instanceVariableNames: 'table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Seaside-ExampleStore'!

!WAStoreOrderView methodsFor: 'as yet unclassified' stamp: 'brp 11/1/2005 16:31'!
buildTable

	table := WATableReport new
		rowPeriod: 1;
		rowColors: #('lightblue' 'white');
		rows: self rows;
		columns: {
			WAReportColumn selector: #date title: 'Date'.
			WAReportColumn selector: #name title: 'Name'.
			WAReportColumn selector: #totalPrice title: 'Total Price'.
		}! !

!WAStoreOrderView methodsFor: 'as yet unclassified' stamp: 'brp 11/1/2005 16:07'!
children

	^ Array with: table! !

!WAStoreOrderView methodsFor: 'as yet unclassified' stamp: 'brp 11/1/2005 16:07'!
initialize

	super initialize.
	self buildTable! !

!WAStoreOrderView methodsFor: 'as yet unclassified' stamp: 'kph 6/16/2006 03:49'!
renderContentOn: html

	html form:
		[ html heading: 'Orders' level: 3.
		html render: table.
		html submitButton callback: [ self answer ]; text: 'Done' ]! !

!WAStoreOrderView methodsFor: 'as yet unclassified' stamp: 'brp 11/1/2005 16:10'!
rows

	^ self session root orders read: #date! !

Object subclass: #WAOrder
	instanceVariableNames: 'dateAndTime cart shippingAddress billingAddress creditCard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Seaside-ExampleStore'!

!WAOrder commentStamp: '<historical>' prior: 0!
WAStoreRepository maintains a collection of WAOrder instances indexed by Date.!

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:40'!
billingAddress

	^ billingAddress! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:39'!
billingAddress: aWAStoreAddress 

	billingAddress := aWAStoreAddress ! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:40'!
cart

	^ cart! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:40'!
cart: aWAStoreCart 

	^ cart := aWAStoreCart! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:53'!
creditCard

	^ creditCard! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:53'!
creditCard: aWAStoreCreditCard

	creditCard := aWAStoreCreditCard! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 14:01'!
date

	^ self dateAndTime asDate! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:38'!
dateAndTime

	^ dateAndTime ifNil: [ dateAndTime := DateAndTime now ]! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:58'!
name

	^ self shippingAddress name! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 11/1/2005 16:28'!
price

	^ 5.4! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:39'!
shippingAddress

	^ shippingAddress! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 13:39'!
shippingAddress: aWAStoreAddress 

	shippingAddress := aWAStoreAddress ! !

!WAOrder methodsFor: 'as yet unclassified' stamp: 'brp 11/1/2005 16:30'!
totalPrice

	^ self cart totalPrice! !

Object subclass: #WAStoreRepository
	instanceVariableNames: 'inventory orders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Seaside-ExampleStore'!

!WAStoreRepository commentStamp: '<historical>' prior: 0!
This class is the root of the Magma repository.

It replaces WAStoreInventory. It maintains two indexed MagmaCollections: 
	- inventory
	- orders

!

!WAStoreRepository class methodsFor: 'as yet unclassified' stamp: 'brp 11/4/2005 12:20'!
create
	"This is a convenience method to create the MagmaRepository"

	self create: MagmaLocalLocation default path.
! !

!WAStoreRepository class methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 12:04'!
create: fullyQualifiedPathString

	MagmaRepositoryController create: fullyQualifiedPathString root: self new.
! !

!WAStoreRepository class methodsFor: 'as yet unclassified' stamp: 'brp 11/4/2005 12:20'!
delete
	"This is a convenience method to delete the MagmaRepository"

	self delete: MagmaLocalLocation default path.
! !

!WAStoreRepository class methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 12:07'!
delete: fullyQualifiedPathString

	MagmaRepositoryController delete: fullyQualifiedPathString.
! !

!WAStoreRepository methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 12:09'!
initialize

	super initialize.
	self 
		initializeInventory; 
		initializeOrders
! !

!WAStoreRepository methodsFor: 'as yet unclassified' stamp: 'cmm 11/1/2005 00:37'!
initializeInventory

	"Create the MagmaCollection and its indices"
	inventory := MagmaCollection new
		addIndex: ((MaSearchStringIndex attribute: #title) keySize: 128; yourself) ;
		addIndex: ((MaKeywordIndex attribute: #keywords) keySize: 64; yourself) ;
		yourself.

	"Use the original class to populate the collection..."
	WAStoreInventory new allItems do: [ :item | inventory add: item  ].
! !

!WAStoreRepository methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 14:01'!
initializeOrders

	orders := MagmaCollection  new 
		addIndex: ((MaAsciiStringIndex attribute: #name) keySize: 128; yourself);
		addIndex: (MaDateIndex attribute: #date);
		yourself.
! !

!WAStoreRepository methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 12:09'!
inventory

	^ inventory! !

!WAStoreRepository methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 12:09'!
orders

	^ orders! !

!WAStore class methodsFor: '*magma-seaside-exampleStore' stamp: 'brp 10/28/2005 11:30'!
initialize

	| application |
	application := self registerAsApplication: 'store'.
	application configuration 
		addAncestor: WAMagmaConfiguration new.

	^ application! !

!WAStore class methodsFor: '*magma-seaside-exampleStore' stamp: 'brp 11/4/2005 12:29'!
workspace
	"WAStore workspace"
'"-----------------------------------------------------------------------------------------------------------------
 Create the Magma repository in a local directory
-----------------------------------------------------------------------------------------------------------------"
WAStoreRepository create.

"-----------------------------------------------------------------------------------------------------------------
 Open the repository with a local session.
-----------------------------------------------------------------------------------------------------------------"
session := MagmaLocalLocation default newSession.
session connectAs: ''brp''.

"-----------------------------------------------------------------------------------------------------------------
 Explore the repository
-----------------------------------------------------------------------------------------------------------------"
session root explore.
session root inventory size.			"40"
session root orders size.				"0"
session root inventory anyOne explore.

"-----------------------------------------------------------------------------------------------------------------
 Interrogate the inventory...
-----------------------------------------------------------------------------------------------------------------"
Transcript clear.
session root inventory do: [ :x | Transcript show: x; cr ].
(session root inventory read: #title at: ''Uni'' ) do: [ :x | Transcript show: x; cr ].
(session root inventory read: #title from: ''Sake'' to: ''Tai'') do: [ :x | Transcript show: x; cr ].

"-----------------------------------------------------------------------------------------------------------------
 Close the repository.
-----------------------------------------------------------------------------------------------------------------"
session disconnectAndClose. 
session := nil. 
Smalltalk garbageCollect. MagmaSession allInstances. "should be #()"

"-----------------------------------------------------------------------------------------------------------------
 Initialise the WAStore application and start Comanche/Seaside
-----------------------------------------------------------------------------------------------------------------"
WAStore initialize.
WAKom startOn: 8080.

"-----------------------------------------------------------------------------------------------------------------
 Once you have made an order via WAStore, you can connect to the repository
 via the controller managed by WAMagmaSession.
-----------------------------------------------------------------------------------------------------------------"
session := MagmaLocalLocation default newSession.
session connectAs: ''brp''.

session root orders size.
(session root orders read: #date) anyOne.

session disconnect. session := nil.

"-----------------------------------------------------------------------------------------------------------------
 Stop Comanche/Seaside
-----------------------------------------------------------------------------------------------------------------"
WAKom stop.
MagmaRepositoryController initialize.  "closes all repositories."

"-----------------------------------------------------------------------------------------------------------------
 Delete the repository.
-----------------------------------------------------------------------------------------------------------------"
WAStoreRepository delete.
'
	openInWorkspaceWithTitle: 'The Sushi Store: Seaside meets Magma'


! !

!WAStoreFillCart methodsFor: '*magma-seaside-examplestore' stamp: 'brp 10/28/2005 13:13'!
browse
	"Read the entire Magma collection"

	self displayItems: (self inventory read: #title)! !

!WAStoreFillCart methodsFor: '*magma-seaside-examplestore' stamp: 'kph 6/16/2006 03:28'!
inventory

	^ self session root inventory ! !

!WAStoreFillCart methodsFor: '*magma-seaside-examplestore' stamp: 'kph 6/16/2006 03:50'!
renderNavBarOn: html
	html form:
		[ html bold: 'Search MagmaCollection:'.
		html space.
		html textInput value: ''; callback: [ : v | self search: v ] ].
	html anchor callback: [ self browse ]; text: 'Browse'.
	html break.
	self hasOrders ifTrue: 
		[ html 
			anchor callback: [ self showOrders ] ; text: 'Orders'. ].
	cart hasItems ifTrue: 
		[ html break.
		html anchor callback: [ self checkout ]; text: 'Checkout'. ]! !

!WAStoreFillCart methodsFor: '*magma-seaside-examplestore' stamp: 'cmm 11/3/2005 12:17'!
search: aString

	(self inventory read: #title from: aString to: aString maAlphabeticalNext)
		ifEmpty: 
			[ (self inventory read: #keywords from: aString to: aString maAlphabeticalNext)
				ifEmpty: [ main inform: 'No items match ', aString printString ]
				ifNotEmpty: [ : results | self displayItems: results ] ]
		ifNotEmptyDo: [ :results | self displayItems: results ].! !

!WAStoreFillCart methodsFor: '*magma-seaside-examplestore' stamp: 'cmm 11/2/2005 21:13'!
showOrders

	self show: WAStoreOrderView new! !

!WAStoreItem methodsFor: '*magma-seaside-examplestore' stamp: 'cmm 11/1/2005 00:36'!
keywords
	^ (title substrings, description substrings) asSet! !

!WAStoreTask methodsFor: '*magma-seaside-examplestore' stamp: 'brp 11/4/2005 12:19'!
shipTo: shippingAddress billTo: billingAddress payWith: aCreditCard
	"Store the order in Magma"

	| order |
	order := WAOrder new
				cart: cart;
				shippingAddress: shippingAddress;
				billingAddress: billingAddress;
				creditCard: aCreditCard;
				yourself.

	self session commit: [ self session root orders add: order ].


! !
WAStore initialize!
